package ch.zhaw.projekt2.turnierverwaltung;

import javafx.scene.layout.Pane;

public abstract class FXController {
    TournamentDecorator tournamentDecorator;
    FactoryDecorator factoryDecorator;
    FileIO fileIO;
    Pane pane;

    public void setup(TournamentDecorator tournamentDecorator, FileIO fileIO, FactoryDecorator factoryDecorator, Pane pane){
        this.tournamentDecorator = tournamentDecorator;
        this.fileIO = fileIO;
        this.factoryDecorator = factoryDecorator;
        this.pane = pane;
        tournamentDecorator.addListener(new IsObserver() {
            @Override
            public void update() {
                loadContent();
            }
        });
        factoryDecorator.addListener(new IsObserver() {
            @Override
            public void update() {
                loadContent();
            }
        });
    }

    public abstract void loadContent();

    protected TournamentDecorator getTournamentDecorator() {
        return tournamentDecorator;
    }

    protected FactoryDecorator getFactoryDecorator() {
        return factoryDecorator;
    }

    protected FileIO getFileIO() {
        return fileIO;
    }

    protected Pane getPane() {
        return pane;
    }
}
